<?php
defined('_JEXEC') or die;
jimport('joomla.application.component.controllerform');

/* Mozaika контроллер */
class MozaikaControllerMozaika extends JControllerForm
{
	/* Переопределение метода для проверки, 
	   может ли пользователь редактировать существующую запись */
	protected function allowEdit($data = array(), $key = 'id')
	{
		$recordId = (int)isset($data[$key]) ? $data[$key] : 0;

		if ($recordId)
		{
			/* Проверка редактирования на уровне записи */
			return JFactory::getUser()->authorise('core.edit', 'com_mozaika.message.' . $recordId);
		}
		else
		{
			/* Проверка редактирования на уровне компонента */
			return parent::allowEdit($data, $key);
		}
	}
}