<?php
defined('_JEXEC') or die;
jimport('joomla.form.helper');
JFormHelper::loadFieldClass('list');

/* Класс поля формы Mozaika компонента Mozaika */
class JFormFieldMozaika extends JFormFieldList
{
	/* Тип поля */
	protected $type = 'Mozaika';
 
	/* Метод для получения списка опций для поля списка */
	protected function getOptions() 
	{
		$options = array();
		$db = JFactory::getDBO();
		$query = $db->getQuery(true);
		/* Случай для создания меню */
		if($this->id == 'jform_request_id'){
		    $query->select('#__mozaika.id as id, mozaika, #__categories.title as category, catid')
				    ->from('#__mozaika')
				    ->leftJoin('#__categories on catid = #__categories.id');
		    $db->setQuery($query);
		    $messages = $db->loadObjectList();
            if ($messages)
		    {
			    foreach($messages as $message) 
			    {
				    $options[] = JHtml::_('select.option', $message->id, $message->mozaika .
										($message->catid ? ' (' . $message->category . ')' : ''));
			    }
		    }
		}else{
		    $query->select('#__mozaika.id as id,  mozaika, commnt, swfwdt, osnfon, podlka, alphai, endigr, pazzly,
			                                               colswf, colset, alpset, colvfn, colvob, editra, editrb,
							#__categories.title as category, catid')
			      ->from('#__kartarf')
			      ->leftJoin('#__categories on catid = #__categories.id');
		    $db->setQuery($query);
		    $messages = $db->loadObjectList();
            if ($messages)
		    {
			    foreach($messages as $message) 
			    {
				    $options[] = JHtml::_('select.option', $message->id, $message->kartarf, $message->commnt, $message->swfwdt, 
					                                    $message->osnfon, $message->podlka, $message->alphai, $message->endigr, 
														$message->pazzly, $message->colswf, $message->colset, $message->alpset, 
														$message->colvfn, $message->colvob, $message->editra, $message->editrb.
														($message->catid ? ' (' . $message->category . ')' : ''));
				}
			}
		}
		$options = array_merge(parent::getOptions(), $options);
		return $options;
	}
}