﻿package doc_as {
	
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.display.*;
	import flash.geom.Rectangle;
	import flash.geom.Point;
	
	public class Otrabotka {
		
		private var par:Object = Main.par;
		private var stg:Stage = Main.stg;

		public function Otrabotka() {
			
		}
		
		/* Аргументы: 1.Колич.фрагм.в данн.варианте игры,  */
		public function configuracya(arg1:int, arg2:BitmapData):Array{
			var arrVr1:Array = this.confRazm(arg1);
			var arrVr2:Array = this.fragmRasstan(arg2, arrVr1[0], arrVr1[2]);   //frgm
			var arrVr3:Array = this.schemaRasst(arg1);
			var arrVr4:Array = this.sozdSprite(arrVr1[2], 750/arrVr3[0]);       //sprt
			var arrVr5:Array = this.randRasstArrays(arrVr2, arrVr4, arrVr1[1]);
			//krdI = arrVr1[1];
			return arrVr5;
		}
		
		/* Получение трёхмерного массива размеров "правильных" и случайных координат расстановки
		   фрагментов и координат копирования пикселей загруженной картинки. Аргумент: количество 
		   фрагментов картинки в данном варианте игры */
		private function confRazm(arg1:int):Array{
			var rzm:Number;
			var rezult:Array = new Array();
			rezult[0] = new Array();                /* Принимает координаты копирования фрагментов */
			rezult[0][0] = new Array();             /* Координаты X --- */
			rezult[0][1] = new Array();             /* Координаты Y --- */
			rezult[1] = new Array();                /* Принимает "правильные" координаты фрагментов */
			rezult[1][0] = new Array();             /* Координаты X --- */
			rezult[1][1] = new Array();             /* Координаты Y --- */
			rezult[2] = new Array();                /* Принимает первонач. координаты фрагментов */
			rezult[2][0] = new Array();             /* Координаты X --- */
			rezult[2][1] = new Array();             /* Координаты Y --- */
			var rasst:Array = this.schemaRasst(arg1);
			rzm = 750/rasst[0];
			/* Получение "правильных" и случайных координат */
			for(var i:int = 0; i < rasst[0]; i++){
				for(var k:int = 0; k < rasst[1]; k++){
					rezult[0][0].push(rzm * i);
					rezult[0][1].push(rzm * k);
					rezult[1][0].push(25 + rzm * i);
					rezult[1][1].push(75 + rzm * k);
					rezult[2][0].push(25 + Math.floor(Math.random()*(750 - rzm)));
					rezult[2][1].push(75 + Math.floor(Math.random()*(500 - rzm)));
				}
			}
			return rezult;
		}
		
		/* Random-сортировка фрагментов картинки, в качестве аргументов из класса
		   Main принимаются массивы frgm, sprt, krdI и после отработки данного 
		   метода полученные значения присваиваются этим же массивам.*/
		private function randRasstArrays(arg1:Array, arg2:Array, arg3:Array):Array{
			var rezult:Array = new Array();
			rezult[0] = new Array();
			rezult[1] = new Array();
			rezult[2] = new Array();
			rezult[2][0] = new Array();
			rezult[2][1] = new Array();
			var leng:int = arg1.length;
			var rand:int;
			for(var i:int = 0; i < leng; i++){
				rand = Math.floor(Math.random() * arg1.length);
				rezult[0].push(arg1[rand]);
				arg1.splice(rand, 1);
				rezult[1].push(arg2[rand]);
				arg2.splice(rand, 1);
				rezult[2][0].push(arg3[0][rand]);
				arg3[0].splice(rand, 1);
				rezult[2][1].push(arg3[1][rand]);
				arg3[1].splice(rand, 1);
			}
			
			return rezult;
		}
		
		/* Создание спрайтов управляющих объектами Bitmap. Аргументы: 1.Массив координат присвоенных
		   фрагментам, 2.Размер стороны фрагмента. */
		private function sozdSprite(arg1:Array, arg2:Number):Array{
			var rezult:Array = new Array();
			for(var i:int = 0; i < arg1[0].length; i++){
				var spr:Sprite = new Sprite();
				spr.graphics.beginFill(0xCCFF00);
				spr.graphics.drawRect(0, 0, arg2, arg2);
				spr.graphics.endFill();
				spr.x = arg1[0][i];
				spr.y = arg1[1][i];
				spr.alpha = 0;
				rezult.push(spr);
			}
			return rezult;
		}
		
		/* Получение схемы расстановки фрагментов, где arg1:количество фрагментов картинки - принимает 
		   значения: 6, 24, 96, 150, 600, возвр.массив из 2 эл, где [0] - колич.колонок в расстановке,
		   [1] - колич.рядов в расстановке. */
		public function schemaRasst(arg1:int):Array{
			var rezult:Array = new Array();
			if(arg1 == 6)   rezult = [3, 2];
			if(arg1 == 24)  rezult = [6, 4];
			if(arg1 == 96)  rezult = [12, 8];
			if(arg1 == 150) rezult = [15, 10];
			if(arg1 == 600) rezult = [30, 20];
			return rezult;
		}
		
		/* Загрузка внешнего файла в swf, Аргументы: 1.Путь к загруж.файлу, 2.3.Координаты X, Y
		   присваиваемые загружаемому файлу. */
		public function zagrVneshFile(arg1:String, arg2:Number, arg3:Number):Loader{
		    var req:URLRequest = new URLRequest(arg1);
			var zagr:Loader = new Loader();
			zagr.load(req);
			zagr.x = arg2;
			zagr.y = arg3;
			return zagr;
		}
		/* Циклическое присвоение свойству visible всем элементам массива false или true */
		public function visNotVisibl(arg1:Array, arg2:Boolean):void{
			for(var i:int = 0; i < arg1.length; i++){
				arg1[i].visible = arg2;
			}
		}
		/* Получ.фрагментов картинки и присв.им координат. Аргументы: 1.Картинка-исходник,
		   2.Двумерный массив координат копирования, 3.Двум.массив координат расстановки,
		   Возвращает: массив фрагментов*/
		private function fragmRasstan(arg1:BitmapData, arg2:Array, arg3:Array):Array{
			var rezult:Array = new Array();
			for(var i:int = 0; i < arg2[0].length; i++){
				var rect:Rectangle = new Rectangle(arg2[0][i], arg2[1][i], arg2[1][1], arg2[1][1]);
				var pt:Point = new Point(0, 0);
				var bmD:BitmapData = new BitmapData(arg2[1][1], arg2[1][1], false, 0xFFFFFF);
				bmD.copyPixels(arg1, rect, pt);
				var bmB:Bitmap = new Bitmap(bmD);
				bmB.smoothing = true;
				bmB.x = arg3[0][i];
				bmB.y = arg3[1][i];
				rezult.push(bmB);
			}
			return rezult;
		}
	}
}
